mod Ex06a logic: 'cl'

incl Mtex

incl Mauxa

rem 
  6. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 1.4.2004
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  2 TESTY: 60 bodov = 30+30
  FINALTERM: 40 bodov
  PREMIOVE ULOHY
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [2i1,2i2,2i3,2i4]
  PREDNASKA: Jan Komara
  CVICENIA: Jan Komara, Jozef Nagy
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane zoznamom 
  (triedenie, aplikacie). Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subory \it  ex06*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 
         \items 
          \item \para See \it  <cl>/2i/doc/svp.ps  \end. 
         \end
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Sorting of Lists.  \end 

rem 
  \para \bf  Insertion sort.  \end 

fun/2 Insert 
  Insert(a,x) = Foo

fun Isort 
  Isort(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_insert_perm
    Perm(Insert(a,x),a,x)
  \end
  \eq Spec_insert_ord
    Ord(x) -> Ord Insert(a,x)
  \end

lemma Lemma_spec_insert_perm
  Perm(i,a,w) -> Perm((v,i),a,v,w)
proof 
 use Perm_cancel_conc_elem.0; 0; v; i; a,0; w proved..

thm Spec_insert_perm
  Perm(Insert(a,x),a,x)

thm Spec_insert_ord
  Ord(x) -> Ord Insert(a,x)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_isort_perm
    Perm(Isort(x),x)
  \end
  \eq Spec_isort_ord
    Ord Isort(x)
  \end

lemma Lemma_spec_isort_perm
  Perm(iw,w) & Perm(ivw,v,iw) -> Perm(ivw,v,w)
proof 
 use Perm_trans; ivw; v,iw; v,w
  use Perm_pair; iw; w; v proved...

thm Spec_isort_perm
  Perm(Isort(x),x)

thm Spec_isort_ord
  Ord Isort(x)

rem 
  \para \bf  Merge sort.  \end 

fun Msplit 
  Msplit(x) = Foo

fun/2 Merge 
  Merge(x,y) = Foo

fun Msort 
  Msort(x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_msplit_output
    \e y\e z Msplit(x) = y,z
  \end
  \eq Spec_msplit_perm
    Msplit(x) = y,z -> Perm(x,y++z)
  \end
  \eq Spec_msplit_l
    Msplit(x) = y,z -> L(x) = L(y)+L(z) & (L(y) = L(z) \/ L(y) = L(z)+1)
  \end

thm Spec_msplit_output
  \e y\e z Msplit(x) = y,z

lemma Lemma_spec_msplit_perm
  Perm(w,y++z) -> Perm((u,v,w),u,y++(v,z))
proof 
 use Perm_cancel_conc_elem.0; u,0; v; w; u,y; z
  weak Perm((u,v,w),u,y++(v,z)) <-> Perm((u,w),u,y++z)
   use Perm_pair; w; y++z; u proved....

thm Spec_msplit_perm
  Msplit(x) = y,z -> Perm(x,y++z)
proof  proved.

thm Spec_msplit_l
  Msplit(x) = y,z -> L(x) = L(y)+L(z) & (L(y) = L(z) \/ L(y) = L(z)+1)
proof  proved.

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_merge_perm
    Perm(Merge(x,y),x++y)
  \end
  \eq Spec_merge_ord
    Ord(x) & Ord(y) -> Ord Merge(x,y)
  \end

lemma Lemma_spec_merge_perm
  Perm(m,v1,w1++w2) -> Perm((v2,m),v1,w1++(v2,w2))
proof 
 use Perm_cancel_conc_elem.0; 0; v2; m; v1,w1; w2 proved..

thm Spec_merge_perm
  Perm(Merge(x,y),x++y)

thm Spec_merge_ord
  Ord(x) & Ord(y) -> Ord Merge(x,y)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_msort_perm
    Perm(Msort(x),x)
  \end
  \eq Spec_msort_ord
    Ord Msort(x)
  \end

lemma Lemma_spec_msort_perm
  Perm(m1,u,y) & Perm(m2,v,z) & Perm(m,m1++m2) & Perm(w,y++z) -> Perm(m,u,v,w)
proof 
 cut* Perm(m,(u,y)++(v,z))
  weak Perm(w,y++z)
   weak* Perm(m,u,v,w)
    use Perm_trans; m; m1++m2; u,y++(v,z)
     weak Perm(m,m1++m2)
      split Perm(m1++m2,u,y++(v,z)) -> Perm(m,u,y++(v,z)).2,1,0
       weak* Perm(m,u,y++(v,z))
        use Perm_conc; m1; u,y; m2; v,z proved..
       proved.....
  weak Perm(m1,u,y); Perm(m2,v,z); Perm(m,m1++m2)
   use Perm_trans; m; u,y++(v,z); u,v,w
    weak Perm(m,u,y++(v,z))
     split Perm((u,y++(v,z)),u,v,w) -> Perm(m,u,v,w).2,1,0
      weak* Perm(m,u,v,w)
       use Perm_sym; w; y++z
        weak Perm(w,y++z)
         use Perm_cancel_conc_elem.0; u,y; v; z; u,0; w
          weak Perm((u,y++(v,z)),u,v,w) <-> Perm((u,y++z),u,w)
           use Perm_pair; y++z; w; u proved......
      proved......

thm Spec_msort_perm
  Perm(Msort(x),x)

thm Spec_msort_ord
  Ord Msort(x)

