mod Ex06b logic: 'cl'

incl Mtex

incl Mauxb

rem 
  6. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 1.4.2004
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  2 TESTY: 60 bodov = 30+30
  FINALTERM: 40 bodov
  PREMIOVE ULOHY
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
         SUBJECT: prihlasenie sa do skupiny [2i1,2i2,2i3,2i4]
  PREDNASKA: Jan Komara
  CVICENIA: Jan Komara, Jozef Nagy
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane zoznamom 
  (triedenie, aplikacie). Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subory \it  ex06*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 
         \items 
          \item \para See \it  <cl>/2i/doc/svp.ps  \end. 
         \end
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Applications of Lists.  \end 

rem 
  \para \bf  Subsection. Finite Sets.  \end 

rem 
  \para \bf  Set membership.  \end 

pred/2 Inset 'Tex_p2_set_in'
  Inset(a,s) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_inset
    Set(s) -> Inset(a,s) <-> a in s
  \end

thm Spec_inset
  Set(s) -> Inset(a,s) <-> a in s

rem 
  \para \bf  Set insertion.  \end 

fun/2 Insert 'Tex_f2_set_insert'
  Insert(s,a) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_insert_in
    Set(s) -> b in Insert(s,a) <-> b = a \/ b in s
  \end
  \eq Spec_insert_set
    Set(s) -> Set Insert(s,a)
  \end

thm Spec_insert_in
  Set(s) -> b in Insert(s,a) <-> b = a \/ b in s

thm Spec_insert_set
  Set(s) -> Set Insert(s,a)

rem 
  \para \bf  Set deletion.  \end 

fun/2 Delete 'Tex_f2_set_delete'
  Delete(s,a) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Spec_delete_in
    Set(s) -> b in Delete(s,a) <-> b in s & b != a
  \end
  \eq Spec_delete_set
    Set(s) -> Set Delete(s,a)
  \end

thm Spec_delete_in
  Set(s) -> b in Delete(s,a) <-> b in s & b != a

thm Spec_delete_set
  Set(s) -> Set Delete(s,a)

